/*
 *	Wise HTML Abstract Text generator
 *	By CSK (Shikai, Chen)
 *  http://www.csksoft.net
 *  version: 1
 *
 *  **********USAGE:
 *  <dest> = html_elem_trace( < source> )
 *
 *  **********INTRODUCTION:
 *  Let's suppose there exists the following html source code:
 *
 *  var orginal_html= "<p>this is a truncated html source<a href=\"some URL\">some hyperlink</a>.<BR>more text</p><p>one more</p>"
 *  
 *  For some reason, you want to generate an abstract text of this orginal_html.
 *  An instinctive method may like this:
 *
 *  var abstract = orginal_html.substring(0, abstract_length);
 *
 *  But soon you will find such method does not always work well, 
 *  For example, the abstract code maybe "<p>this is a truncated html source<a href=\"s"
 *  In such case, it will bring much trouble when render the source code in a browser.
 *  
 *  html_elem_trace() is the exact answer to solve such problem:
 *  
 *  var refined_abstract = html_elem_trace(abstract);
 *
 *  [RESULT]
 *  refined_abstract: "<p>this is a truncated html source</p>"
 *
 *  Enjoy it!
 */

function html_wise_cut(str)
{
  // case :
  // input  "<p>sdas<a hre"
  // output "<p>sdas"
  var n_pos = str.length-1;
  while(n_pos>=0)
  {
    var current_char  = str.charAt(n_pos--);
    if (current_char == ">") break;
    if (current_char == "<")
    { //orginal cut is located in a element, 
      //so we should delete the whole element info
      str = str.substring(0,n_pos+1);
      break;
    }
  }
  return str;
}

function get_elem_name(str)
{
  var re =/\/?[a-zA-Z0-9_#]+/i;
  var result;
  result = str.match(re);
  return result[0];
}

function html_elem_trace(str)
{
  
  var element_stk = new Array();
  var exclude_list = new Array("br");
  
  var temp_buff = html_wise_cut(str);
  temp_buff.replace(/<\s*([a-zA-Z0-9_#:]+\b)(?:[^>]*[^\/])?>|<(\/[a-zA-Z0-9_#:]+)>|(\/)>/ig, function($1)
          {
            
            if ($1 == "/>") return "";
            
            var current_elem = get_elem_name($1);
			
			if (current_elem.charAt(0) == "/")
			{
				
				if (element_stk.length>0 && element_stk[element_stk.length-1].toLowerCase() == current_elem.substring(1,current_elem.length).toLowerCase())
				{
					element_stk.pop();		
				}
			}
			else
			{
				for (var pos=0;pos<exclude_list.length;pos++)
				{
					if (exclude_list[pos] == current_elem.toLowerCase()) return;
				}
				element_stk.push(current_elem);
			}
            
          });
  while(element_stk.length)
  {
	temp_buff+="</" + element_stk.pop() + ">"; 
  }
	return temp_buff;
}


function on_transfer()
{
str=document.getElementById("src").innerText;

str= html_elem_trace(str);
document.getElementById("src").innerText = str;

}

function on_prev()
{
	document.getElementById("prev_div").innerHTML = document.getElementById("src").innerText;
}